/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package generatecrudangular.view;

import generatecrudangular.core.Metadata;
import generatecrudangular.core.Parse;
import generatecrudangular.model.Conexao;
import generatecrudangular.utils.UnzipUtils;
import java.awt.event.ItemEvent;
import java.io.File;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang3.text.WordUtils;

/**
 *
 * @author viniciusluciene
 */
public class frmProjetoSTS extends javax.swing.JFrame {

    private Conexao conexao;
    private List<String> tabelas = new ArrayList<>();
    private List<String> tabelasSelecionadas = new ArrayList<>();

    public List<String> getTabelas() {
        return tabelas;
    }

    public List<String> getTabelasSelecionadas() {
        return tabelasSelecionadas;
    }

    /**
     * Creates new form frmProjetoSTS
     */
    public frmProjetoSTS() {
        initComponents();
        this.setLocationRelativeTo(null);
        this.conexao = new Conexao();
        jBGerarProjeto.setEnabled(false);
        jBGerarArquivos.setEnabled(false);
        jTFArquivoConfig.setEditable(false);
        jTFAbrirProjeto.setEditable(false);
        jTFSalvarProjeto.setEditable(false);
        ItemSelecionadoComboBox(jCB_Sgdb.getSelectedItem().toString());
        jCB_Sgdb.addItemListener((ItemEvent e) -> {
            //
            if (e.getStateChange() == ItemEvent.SELECTED) {
                String valorSelecionado = e.getItem().toString();
                ItemSelecionadoComboBox(valorSelecionado);
            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jCB_Sgdb = new javax.swing.JComboBox<>();
        jLabel3 = new javax.swing.JLabel();
        jTUsuario = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jPassSenha = new javax.swing.JPasswordField();
        jButton1 = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jTBanco = new javax.swing.JTextField();
        jTServidor = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListTabelas = new javax.swing.JList<>();
        jLabel7 = new javax.swing.JLabel();
        jBGerarArquivos = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jLabel18 = new javax.swing.JLabel();
        jTFArquivoConfig = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jTFGrupo = new javax.swing.JTextField();
        jTFNome = new javax.swing.JTextField();
        jTFArtefato = new javax.swing.JTextField();
        jTFDescricao = new javax.swing.JTextField();
        jTFPacote = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTFSalvarProjeto = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jBGerarProjeto = new javax.swing.JButton();
        jLabel15 = new javax.swing.JLabel();
        jTFAbrirProjeto = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setFont(new java.awt.Font("Lucida Grande", 0, 24)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Gerar Api Spring Boot");

        jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jCB_Sgdb.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "MySql", "Sql Serve", "Postgress" }));

        jLabel3.setText("Selecione o SGDB");

        jLabel4.setText("Usuario do Banco");

        jLabel5.setText("Senha do Banco");

        jButton1.setText("Conectar");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel6.setText("Banco de Dados");

        jLabel8.setText("Servidor");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel3))
                    .addComponent(jCB_Sgdb, javax.swing.GroupLayout.PREFERRED_SIZE, 118, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTServidor, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jTBanco, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jTUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPassSenha, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(28, 28, 28)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel8)
                    .addComponent(jLabel6)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jCB_Sgdb, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTServidor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTBanco, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTUsuario, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jPassSenha, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jButton1)))
                    .addComponent(jLabel4)
                    .addComponent(jLabel5))
                .addContainerGap(12, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jScrollPane1.setViewportView(jListTabelas);

        jLabel7.setText("TABELAS");

        jBGerarArquivos.setText("Gerar Arquivos");
        jBGerarArquivos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBGerarArquivosActionPerformed(evt);
            }
        });

        jButton5.setText("Caminho");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jLabel18.setText("Arquivo config");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 522, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel7))
                        .addGap(18, 18, 18)
                        .addComponent(jBGerarArquivos, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(jLabel18)
                        .addGap(12, 12, 12)
                        .addComponent(jTFArquivoConfig, javax.swing.GroupLayout.PREFERRED_SIZE, 633, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton5)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel18)
                    .addComponent(jTFArquivoConfig, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jBGerarArquivos, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jLabel10.setText("Grupo");

        jLabel11.setText("Artefato");

        jLabel12.setText("Nome");

        jLabel13.setText("Descrição");

        jLabel14.setText("Pacote");

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jLabel14)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jTFPacote, javax.swing.GroupLayout.PREFERRED_SIZE, 356, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addComponent(jLabel10)
                                .addGap(42, 42, 42))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel4Layout.createSequentialGroup()
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jLabel13, javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel12, javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel11, javax.swing.GroupLayout.Alignment.LEADING))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTFDescricao, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 356, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTFNome, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 356, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTFArtefato, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 356, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTFGrupo, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 356, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(16, Short.MAX_VALUE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFGrupo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFArtefato, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel12))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFDescricao, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel13))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFPacote, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel14))
                .addContainerGap())
        );

        jLabel9.setText("Metadata");

        jLabel2.setText("Salvar Projeto");

        jButton2.setText("Caminho");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jBGerarProjeto.setText("Gerar Projeto");
        jBGerarProjeto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBGerarProjetoActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTFSalvarProjeto)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel9)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jBGerarProjeto, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTFSalvarProjeto, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel9)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jBGerarProjeto, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        jLabel15.setText("Abir Projeto");

        jButton4.setText("Caminho");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jLabel16.setText("Criar projeto");

        jLabel17.setText("Abrir ptojeto existente");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(6, 6, 6))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel15)
                .addGap(12, 12, 12)
                .addComponent(jTFAbrirProjeto)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton4)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel17)
                    .addComponent(jLabel16))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(25, 25, 25)
                .addComponent(jLabel16)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel17)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel15)
                    .addComponent(jTFAbrirProjeto, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed

        if (jTServidor.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "Informe o caminho do Servidor");
            return;
        };

        if (jTBanco.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "Informe o Banco de Dados");
            return;
        };

        if (jTUsuario.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "Informe o Usuario");
            return;
        };

        if (jPassSenha.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "Informe a Senha");
            return;
        };

        if (!jTFArquivoConfig.getText().equals("")) {
            jBGerarArquivos.setEnabled(true);
        }

        final Carregando carregando = new Carregando();
        carregando.setVisible(true);

        Thread t = new Thread() {
            @Override
            public void run() {
                super.run();
                conexao.setServidor(jTServidor.getText());
                conexao.setUsuario(jTUsuario.getText());
                conexao.setSenha(jPassSenha.getText());
                conexao.setBanco(jTBanco.getText());
                conexao.setUrl(conexao.getUrl().replace("#SERVIDOR", jTServidor.getText()).replace("#BANCO", jTBanco.getText()));

                try {
                    tabelas.addAll(getTables(conectaBanco(conexao)));

                    DefaultListModel model = new DefaultListModel();
                    for (String tabela : tabelas) {
                        if (!tabela.equals("schema_version")) {
                            model.addElement(tabela);
                        }
                    }

                    jListTabelas.setModel(model);

                    JOptionPane.showMessageDialog(null,
                            "Dados para Conexão:"
                            + "\nBanco: " + conexao.getBanco()
                            + "\nDriver: " + conexao.getDriver()
                            + "\nUsuario: " + conexao.getUsuario()
                            + "\nSenha: " + conexao.getSenha()
                            + "\nUrl: " + conexao.getUrl()
                            + "\nServidor: " + conexao.getUrl());
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(null, "Error: \n".concat(ex.getMessage()));
                    Logger.getLogger(frmPrincipal.class.getName()).log(Level.SEVERE, null, ex);
                }

                carregando.dispose();
            }
        };

        t.start();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jBGerarArquivosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBGerarArquivosActionPerformed
        final Carregando carregando = new Carregando();
        try {
            if (this.jListTabelas.isSelectionEmpty() || jTFArquivoConfig.getText().equals("")) {
                JOptionPane.showMessageDialog(null, "Selecione pelo menos uma tabela para gerados arquivos.\nArquivo config não selecionado.");
                return;
            }

            carregando.setVisible(true);

            List<String> tables = new ArrayList<>();
            tables.addAll(this.jListTabelas.getSelectedValuesList());
            
            File properties = new File(jTFArquivoConfig.getText());
            File destino = new File(jTFAbrirProjeto.getText()+File.separator);
            String pacoteJV = "generatecrudangular".concat(File.separator.concat("templates".concat(File.separator.concat("jv".concat(File.separator)))));
            List<String> templates = Arrays.asList(pacoteJV+"Filter.vm", 
                                                    pacoteJV+"Helper.vm", 
                                                    pacoteJV+"Model.vm",
                                                    pacoteJV+"Repository.vm", 
                                                    pacoteJV+"RepositoryImpl.vm", 
                                                    pacoteJV+"Resource.vm",
                                                    pacoteJV+"Service.vm");

            generateFiles(conectaBanco(conexao), tabelas, tables, templates, properties, destino, true);
            
            JOptionPane.showMessageDialog(null, "Arquivos gerados com Sucesso.");

        } catch (Exception ex) {
            Logger.getLogger(frmProjetoSTS.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            carregando.dispose();
        }

    }//GEN-LAST:event_jBGerarArquivosActionPerformed

    private void jBGerarProjetoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBGerarProjetoActionPerformed

        final Carregando carregando = new Carregando();
        carregando.setVisible(true);

        if (jTFSalvarProjeto.getText().equals("")) {
            carregando.dispose();
            JOptionPane.showMessageDialog(null, "Informe o caminho para salvar o porjeto");
            return;
        } else if (jTFNome.getText().equals("")) {
            carregando.dispose();
            JOptionPane.showMessageDialog(null, "Informe o Nome");
            return;
        } else if (jTFGrupo.getText().equals("")) {
            carregando.dispose();
            JOptionPane.showMessageDialog(null, "Informe o Grupo");
            return;
        } else if (jTFArtefato.getText().equals("")) {
            carregando.dispose();
            JOptionPane.showMessageDialog(null, "Informe o Artefato");
            return;
        } else if (jTFPacote.getText().equals("")) {
            carregando.dispose();
            JOptionPane.showMessageDialog(null, "Informe o Pacote do projeto");
            return;
        }

        Thread t = new Thread(() -> {
            try {
                String url = "https://start.spring.io/starter.zip?name=" + jTFNome.getText() + "&groupId=" + jTFGrupo.getText() + "&artifactId=" + jTFArtefato.getText() + "&version=1.0.0&description=" + jTFDescricao.getText() + "&packageName=" + jTFPacote.getText() + "&type=maven-project&packaging=jar&javaVersion=1.8&language=java&bootVersion=2.3.1.RELEASE&dependencies=devtools&dependencies=flyway&dependencies=mysql&dependencies=data-jpa&dependencies=security&dependencies=web";
                
                String local = jTFSalvarProjeto.getText()+File.separator+jTFNome.getText();
                
                UnzipUtils.download(url, local);
                
                Path origemZip = Paths.get(jTFSalvarProjeto.getText()+File.separator+jTFNome.getText()+".zip");
                
                Path destino = Paths.get(jTFSalvarProjeto.getText()+File.separator+jTFNome.getText()+File.separator);
                
                UnzipUtils.unzip(origemZip.toString(), destino.toString());
                
                File file = new File(origemZip.toString());
                file.delete();
                
                File arquivoConfiguracao = new File(destino.toString()+File.separator+"config.properties");
                UnzipUtils.escreverArquivoConfig(arquivoConfiguracao, jTFPacote.getText());
                
                File caminhoProjeto = new File(destino.toString()+File.separator);
                
                Parse.save(caminhoProjeto, jTFPacote.getText(), true);
                
                carregando.dispose();
                
                JOptionPane.showMessageDialog(null, "Projeto criado com sucesso");
            } catch (Exception ex) {
                Logger.getLogger(frmProjetoSTS.class.getName()).log(Level.SEVERE, null, ex);
            }
        });

        t.start();


    }//GEN-LAST:event_jBGerarProjetoActionPerformed

    private void limparCampos() {
        conexao.setBanco("");
        conexao.setDriver("");
        conexao.setPorta("");
        conexao.setSenha("");
        conexao.setUrl("");
        conexao.setUsuario("");
    }

    private void ItemSelecionadoComboBox(String item) {
        limparCampos();
        switch (item) {
            case "Postgress":
                conexao = new Conexao("jdbc:postgresql://#SERVIDOR:5432/#BANCO", "", "", "org.postgresql.Driver", "", "", "5432");
                jTServidor.setText("localhost");
                jTUsuario.setText("postges");
                jPassSenha.setText("");
                break;

            case "MySql":
                conexao = new Conexao("jdbc:mysql://#SERVIDOR:3306/#BANCO", "", "", "com.mysql.jdbc.Driver", "", "", "3306");
                jTServidor.setText("localhost");
                jTUsuario.setText("root");
                jPassSenha.setText("root");
                break;

            case "Sql Serve":
                conexao = new Conexao("jdbc:sqlserver://#SERVIDOR:1433;databaseName=#BANCO", "", "", "net.sourceforge.jtds.jdbc.Driver", "", "", "1433");
                jTServidor.setText("localhost");
                jTUsuario.setText("sa");
                jPassSenha.setText("");
                break;

            default:
                System.out.printf("Você digitou uma operação inválida.\n");

        }
    }

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        JFileChooser fc1 = new JFileChooser();
        fc1.setDialogTitle("Selecione o Diretorio...");
        fc1.resetChoosableFileFilters();
        jBGerarProjeto.setEnabled(false);

        /**/
        UIManager.put("FileChooser.openDialogTitleText", "Seleçao de aquivos");
        UIManager.put("FileChooser.lookInLabelText", "Local");
        UIManager.put("FileChooser.openButtonText", "Inserir");
        UIManager.put("FileChooser.cancelButtonText", "Sair");
        UIManager.put("FileChooser.fileNameLabelText", "Nome do Arquivo");
        UIManager.put("FileChooser.filesOfTypeLabelText", "Tipo de Arquivo");
        UIManager.put("FileChooser.openButtonToolTipText", "Abrir Selecionado");
        UIManager.put("FileChooser.cancelButtonToolTipText", "Sair");
        UIManager.put("FileChooser.fileNameHeaderText", "Nome do Arquivo");
        UIManager.put("FileChooser.upFolderToolTipText", "Subir Nivel Acima");
        UIManager.put("FileChooser.homeFolderToolTipText", "Desktop");
        UIManager.put("FileChooser.newFolderToolTipText", "Nova Pasta");
        UIManager.put("FileChooser.listViewButtonToolTipText", "Lista");
        UIManager.put("FileChooser.newFolderButtonText", "Criar Nova Pasta");
        UIManager.put("FileChooser.renameFileButtonText", "Renomear");
        UIManager.put("FileChooser.deleteFileButtonText", "Apagar");
        UIManager.put("FileChooser.filterLabelText", "Tipo de Arquivos");
        UIManager.put("FileChooser.detailsViewButtonToolTipText", "Detalhes");
        UIManager.put("FileChooser.fileSizeHeaderText", "Tamanho");
        UIManager.put("FileChooser.fileDateHeaderText", "Data de Modificação");

        SwingUtilities.updateComponentTreeUI(fc1);
        /**/

        fc1.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);

        int res = fc1.showOpenDialog(this);

        File caminho = null;

        if (res == JFileChooser.APPROVE_OPTION) {
            caminho = fc1.getSelectedFile();
            jTFSalvarProjeto.setText(caminho.getAbsolutePath());
            jBGerarProjeto.setEnabled(true);
            //JOptionPane.showMessageDialog(null, "Pasta selecionada: " + caminho.getName());
        } else {
            JOptionPane.showMessageDialog(null, "Operação cancelada.");

        }
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        JFileChooser fc1 = new JFileChooser();
        fc1.setDialogTitle("Selecione o Diretorio...");
        fc1.resetChoosableFileFilters();

        /**/
        UIManager.put("FileChooser.openDialogTitleText", "Seleçao de aquivos");
        UIManager.put("FileChooser.lookInLabelText", "Local");
        UIManager.put("FileChooser.openButtonText", "Inserir");
        UIManager.put("FileChooser.cancelButtonText", "Sair");
        UIManager.put("FileChooser.fileNameLabelText", "Nome do Arquivo");
        UIManager.put("FileChooser.filesOfTypeLabelText", "Tipo de Arquivo");
        UIManager.put("FileChooser.openButtonToolTipText", "Abrir Selecionado");
        UIManager.put("FileChooser.cancelButtonToolTipText", "Sair");
        UIManager.put("FileChooser.fileNameHeaderText", "Nome do Arquivo");
        UIManager.put("FileChooser.upFolderToolTipText", "Subir Nivel Acima");
        UIManager.put("FileChooser.homeFolderToolTipText", "Desktop");
        UIManager.put("FileChooser.newFolderToolTipText", "Nova Pasta");
        UIManager.put("FileChooser.listViewButtonToolTipText", "Lista");
        UIManager.put("FileChooser.newFolderButtonText", "Criar Nova Pasta");
        UIManager.put("FileChooser.renameFileButtonText", "Renomear");
        UIManager.put("FileChooser.deleteFileButtonText", "Apagar");
        UIManager.put("FileChooser.filterLabelText", "Tipo de Arquivos");
        UIManager.put("FileChooser.detailsViewButtonToolTipText", "Detalhes");
        UIManager.put("FileChooser.fileSizeHeaderText", "Tamanho");
        UIManager.put("FileChooser.fileDateHeaderText", "Data de Modificação");

        SwingUtilities.updateComponentTreeUI(fc1);
        /**/

        fc1.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        int res = fc1.showOpenDialog(this);

        File caminho = null;

        if (res == JFileChooser.APPROVE_OPTION) {
            caminho = fc1.getSelectedFile();
            jTFAbrirProjeto.setText(caminho.getAbsolutePath());
        } else {
            JOptionPane.showMessageDialog(null, "Operação cancelada.");
        }
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        if (tabelas.size() > 0) {
            jBGerarArquivos.setEnabled(true);
        }

        JFileChooser file = new JFileChooser();
        file.setDialogTitle("Selecione o arquivo de configuração...");
        file.setApproveButtonText("Selecionar");
        file.setFileFilter(new FileNameExtensionFilter("*.properties", "properties"));
        file.setFileSelectionMode(JFileChooser.FILES_ONLY);
        int showOpenDialog = file.showOpenDialog(null);
        if (showOpenDialog != file.APPROVE_OPTION) {
            jTFArquivoConfig.setText("");
        } else {
            File arquivo = file.getSelectedFile();
            jTFArquivoConfig.setText(arquivo.getPath());
        }
    }//GEN-LAST:event_jButton5ActionPerformed

    private List<String> getTables(Connection connect) throws SQLException {
        List<String> tables = new ArrayList<String>();
        try {
            DatabaseMetaData dbmd = connect.getMetaData();
            String[] tableTypes = {"TABLE"};
            ResultSet rs = dbmd.getTables(null, null, "%", tableTypes);

            while (rs.next()) {
                tables.add(rs.getString("TABLE_NAME"));
            }
        } catch (SQLException e) {
            throw new SQLException("Ocorreu um erro ao obter a lista de tabelas do banco", e);
        }
        return tables;
    }

    public List<File> generateFiles(Connection connect, List<String> allTablesOfDatabase, List<String> tables, List<String> templates, File properties, File destPath, boolean forceEncodingUtf8) throws Exception {
        List<File> generated = new ArrayList<File>();
        try {

            for (String table : tables) {
                for (String template : templates) {
                    File result = Metadata.extract(connect, allTablesOfDatabase, table, template, properties, destPath, forceEncodingUtf8);
                    generated.add(result);
                }
            }
        } catch (Exception e) {
            throw new Exception("Ocorreu um erro ao gerar os arquivos. Foram gerados somente: " + StringUtils.join(generated, ", "), e);
        }
        return generated;
    }

    private Connection conectaBanco(Conexao conexao) throws Exception {
        Class.forName(conexao.getDriver());
        return DriverManager.getConnection(conexao.getUrl(), conexao.getUsuario(), conexao.getSenha());
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(frmProjetoSTS.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(frmProjetoSTS.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(frmProjetoSTS.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(frmProjetoSTS.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new frmProjetoSTS().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBGerarArquivos;
    private javax.swing.JButton jBGerarProjeto;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JComboBox<String> jCB_Sgdb;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JList<String> jListTabelas;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPasswordField jPassSenha;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTBanco;
    private javax.swing.JTextField jTFAbrirProjeto;
    private javax.swing.JTextField jTFArquivoConfig;
    private javax.swing.JTextField jTFArtefato;
    private javax.swing.JTextField jTFDescricao;
    private javax.swing.JTextField jTFGrupo;
    private javax.swing.JTextField jTFNome;
    private javax.swing.JTextField jTFPacote;
    private javax.swing.JTextField jTFSalvarProjeto;
    private javax.swing.JTextField jTServidor;
    private javax.swing.JTextField jTUsuario;
    // End of variables declaration//GEN-END:variables
}
